/* Main gnome include */
#include <gnome.h>

/* our widget include */
#include "my-widget.h"

/* called when MyWidget emits the "changed" signal */
static void
entry_changed(GtkWidget *w, gpointer data)
{
	/* pointer to our label is passed as the data */
	GtkWidget *label = data;
	int number;
	char *string;

	/* get the number in the entry */
	number = my_widget_get_number(MY_WIDGET(w));

	/* set the label to this number */
	string = g_strdup_printf("%d", number);
	gtk_label_set(GTK_LABEL(label), string);
	g_free(string);
}

int
main(int argc, char *argv[])
{
	GtkWidget *window, *box, *label, *entry;

	/* initialize gnome */
	gnome_init("test-program", "0.1", argc, argv);

	/* create a new simple window */
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
			   GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

	box = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(window), box);

	label = gtk_label_new("");
	gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);

	entry = my_widget_new();
	gtk_box_pack_start(GTK_BOX(box), entry, FALSE, FALSE, 0);

	/* connect a signal which will keep our label up to date */
	gtk_signal_connect(GTK_OBJECT(entry), "changed",
			   GTK_SIGNAL_FUNC(entry_changed),
			   label);

	/* set the entry to 170 */
	my_widget_set_number(MY_WIDGET(entry), 170);

	gtk_widget_show_all(window);

	gtk_main();

	return 0;
}
